typedef double Range[2];

void int_cosine(Range x, Range result) {
    
    /* Interval cosine function. 
        Input: interval input, interval result storeage 
        Output: none */
    
    static double pi = 3.14159265358979323846;
    Range z;
    double temp;
    
    /* Scale x by 1/pi and shift so that the low end is in range [0,2) */
    z[0] = fmod(x[0]/pi,2.0);
    if (z[0] < 0.0) z[0] += 2.0;
    
    /* Shift x[1]/pi the same amount. */
    z[1] = (x[1] - x[0])/pi + z[0]; 
    
    if (z[1] >= 3.0) {
        result[0] = -1.0;
        result[1] = 1.0;
    }
    else if (z[1] >= 2.0) {
        result[1] = 1.0;
        if (z[0] <= 1.0) 
            result[0] = -1.0;
        else {
            result[0] = cos(x[0]);
            temp = cos(x[1]);
            if (temp < result[0]) result[0] = temp;
        }
    }
    else if (z[1] >= 1.0) {
        if (z[0] <= 1.0) {
            result[0] = -1.0;
            result[1] = cos(x[0]);
            temp = cos(x[1]);
            if (temp > result[1]) result[1] = temp;
        }
        else {
            result[0] = cos(x[0]);
            result[1] = cos(x[1]);
        }
    }
    else {
        result[0] = cos(x[1]);
        result[1] = cos(x[0]);
    }
    return;
}
